import hoverball.*
import hoverball.math.*

class Clumsy extends Unit
{
   Clumsy ()
   {
      super(null,"Clumsy",0x8888FF)  // Name "Clumsy", Farbe hellblau
   }

   void loop ()
   {
      Sphere sphere = new Sphere(option("world.radius"))  // Parameter auslesen...
      double Qmax = option("unit.charge.max")
      double Fmax = option("unit.engine.max")

      while (look())
      {
         Puck ball = puck(BALL,0,1)       // das ist der Ball
         Puck goal = puck(BALL,self.t,1)  // das ist das "Tor"

         if (ball == null) action(0,-Fmax,Fmax)     // sieht keinen Ball? drehe!
         else {                                     // sieht Ball:
            Vector a = (goal != null)? goal.X.c * ball.X.c :  // berechne
                                       ball.X.c * self.X.c    // Drehachse
            Matrix X = ball.X * Matrix.rot(a,(self.r+ball.r)/sphere.rad)
            Complex x = sphere.warp(X.c)            // X ist die Schussposition

            double l = -x.arg() + Math.max(0.2,1-10*Math.abs(x.arg())) // drehe und
            double r =  x.arg() + Math.max(0.2,1-10*Math.abs(x.arg())) // fahre zu X
            double q = (x.abs() < ball.r)? 0.5 : 0  // falls auf X: Schuss!

            action(q*Qmax,l*Fmax,r*Fmax)
         }
      }
   }
}
