import hoverball._
import hoverball.math._

class Clumsy extends Unit(null, "Clumsy", 0x8888FF) 
{
   override def loop() = {
      val sphere: Sphere = new Sphere(option("world.radius")) // Parameter auslesen...
      val Qmax: Double = option("unit.charge.max")
      val Fmax: Double = option("unit.engine.max")
    
      while (look()) { 
         val ball: Puck = puck(Puck.BALL,0,1)       // das ist der Ball
         val goal: Puck = puck(Puck.BALL,self.t,1)  // das ist das "Tor"
      
         if (ball == null) action(0,-Fmax,Fmax)        // sieht keinen Ball? drehe!
         else {                                        // sieht Ball:
            val a: Vector = // [Vector Operator Overloading fails here!?]
               if (goal != null) Vector.vec(goal.X.c,ball.X.c) // berechne
               else              Vector.vec(ball.X.c,self.X.c) // Drehachse
            val X: Matrix = ball.X * Matrix.rot(a,(self.r+ball.r)/sphere.rad)
            val x: Complex = sphere.warp(X.c)          // X ist die Schussposition
        
            val l: Double = -x.arg()+Math.max(0.2,1-10*Math.abs(x.arg())) // drehe und
            val r: Double =  x.arg()+Math.max(0.2,1-10*Math.abs(x.arg())) // fahre zu X
            val q: Double = if (x.abs() < ball.r) 0.5 else 0 // falls auf X: Schuss!

            action(q*Qmax,l*Fmax,r*Fmax)
         }
      }
   }
}

