/*
   Hoverball
   Copyright (c) 2002-2021 Stefan Bornhofen, Matthias Bornhofen

   This file is part of Hoverball.

   Hoverball is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   Hoverball is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Hoverball. If not, see <http://www.gnu.org/licenses/>.
 */
package hoverball;


// ---- Hoverball Server ---------------------------------------- [Server] ----


/**
 * The server runs several simulators with a hash table.
 * <p>
 * If a client connects to the server with a hash key,
 * it is connected to the corresponding simulator.
 * If the hash key does not yet exist, a new simulator is created.
 * <p>
 * If a client connects to the server without a hash key,
 * a new simulator is created with a random hash key.
 * <p>
 * If all clients are disconnected from a simulator of the server,
 * the simulator destroys.
 */
public final class Server
{
   // ---- static Launcher ----------------------------------------------------

   /**
    * Runs the Server (application!).
    */
   public static void main (String[] args)
   {
      String arg = hoverball.layout.About.arg(args);
      try { new hoverball.simulator.Server((args.length == 0)? null : arg); } catch(java.io.IOException e) { e.printStackTrace(); }
   }
}
