/*
   Hoverball
   Copyright (c) 2002-2021 Stefan Bornhofen, Matthias Bornhofen

   This file is part of Hoverball.

   Hoverball is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   Hoverball is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Hoverball. If not, see <http://www.gnu.org/licenses/>.
 */
package hoverball.layout;

import java.awt.*;


public class Constraints extends GridBagConstraints
{
   public Constraints (int gridx, int gridy, int gridwidth, int gridheight,
                       double weightx, double weighty, Insets insets)
   {
      this(gridx,gridy,gridwidth,gridheight,weightx,weighty,insets,CENTER,BOTH);
   }

   public Constraints (int gridx, int gridy, int gridwidth, int gridheight,
                       double weightx, double weighty, Insets insets, int anchor, int fill)
   {
      this.gridx = gridx;
      this.gridy = gridy;
      this.gridwidth = gridwidth;
      this.gridheight = gridheight;
      this.weightx = weightx;
      this.weighty = weighty;
      this.anchor = anchor;
      this.fill = fill;
      this.insets = (insets != null)? insets : new Insets(0,0,0,0);
      this.ipadx = 0;
      this.ipady = 0;
   }
}

