/*
   Hoverball
   Copyright (c) 2002-2021 Stefan Bornhofen, Matthias Bornhofen

   This file is part of Hoverball.

   Hoverball is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   Hoverball is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Hoverball. If not, see <http://www.gnu.org/licenses/>.
 */
package hoverball.layout;

import java.awt.*;
import javax.swing.*;


public class MyButton extends JButton
{
   private final int width;

   public MyButton (String text, boolean symbol, int width)
   {
      this.width = width;
      if (symbol) setFont(Layout.fontSymbol);
      else setFont(Layout.fontButton);
      setMargin(new Insets(0,0,0,0));
      setFocusPainted(false);
      setText(text);
   }

   public Dimension getPreferredSize ()
   {
      Dimension size = super.getPreferredSize();
      if (width < 0) return size;
      else return new Dimension(width,size.height);
   }

   public Dimension getMinimumSize ()
   {
      Dimension size = super.getMinimumSize();
      if (width < 0) return size;
      else return new Dimension(width,size.height);
   }

   public Dimension getMaximumSize ()
   {
      Dimension size = super.getMaximumSize();
      if (width < 0) return size;
      else return new Dimension(width,size.height);
   }
}
