/*
   Hoverball
   Copyright (c) 2002-2021 Stefan Bornhofen, Matthias Bornhofen

   This file is part of Hoverball.

   Hoverball is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   Hoverball is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Hoverball. If not, see <http://www.gnu.org/licenses/>.
 */
package hoverball.layout;

import java.awt.Cursor;
import java.awt.event.*;
import javax.swing.*;


public class MyInternalFrame extends JInternalFrame
{
   private static Icon icon = null;
   static {
      java.net.URL icon_gif = ClassLoader.getSystemResource("resources/icon.gif");
      if (icon_gif != null) icon = new ImageIcon(icon_gif);
   }

   public MyInternalFrame (String title) { this(title,false,false,false,false); }

   public MyInternalFrame (String title, boolean r, boolean c, boolean m, boolean i)
   {
      super(title,r,c,m,i);

      if (icon != null) setFrameIcon(icon);
      setFrameIcon(null); //####

      JComponent j = (JComponent)getContentPane();
      j.setCursor(Cursor.getDefaultCursor());

      hoverball.Application.desktop.add(this);

      addComponentListener(new ComponentAdapter() {
         public void componentShown (ComponentEvent e) {
            if (Layout.auto_show) hoverball.Application.show();  // open application frame at first time showing!
         }
      });
   }
}
