package hoverball.team.Barbarians_;

import hoverball.math.Matrix;

public class StoredPuckAbs
{
	public final String id;
	public Matrix position = new Matrix();
	public Matrix previous = new Matrix();
	public Matrix newPosition = new Matrix();
	public double lastCycle = 0;
	public double previousTime = 0;
	public double positionTime = 0;
	public String message = "";
	
	/**
	 * @param id
	 * @param pos this must be the absolute position of the puck
	 * @param time
	 */
	public StoredPuckAbs(String id, Matrix pos, double time)
	{
		this.id = id;
		this.position = pos;
		this.positionTime = time;
		this.newPosition = pos;
	}

	public void updatePosition(Matrix newPos, double time)
	{
		previous = position;
		position = new Matrix(newPos);
		previousTime = positionTime;
		positionTime = time;

		if ( previousTime == lastCycle )
		{
			Matrix movement = Matrix.mul(Matrix.inv(position), previous);
			newPosition = Matrix.mul(position, movement);
		} else
			newPosition = position;
	}

	/**
	 * This method must be called at the end of the coordinate-update method in the while(look()) loop
	 * @param time time of update cycle
	 */
	public void updateTimestamp(double time)
	{
		lastCycle = time;
	}
}
